/** @file		IOThread.h
 *  @brief	Disk IO handling thread
 *  @author	netfinity
 */
#pragma once
#include "stdafx.h"

#include "messages.h"

/**
 *  @brief	Disk IO thread, object class
 */
class CIOThread : public CWinThread, public CMessageQueue
{
//	DECLARE_DYNCREATE(CIOThread)

public: //protected:
	CIOThread();           // protected constructor used by dynamic creation
	virtual ~CIOThread();
	DECLARE_MESSAGE_MAP()
public:
	virtual	BOOL	InitInstance();
	virtual int		Run();
	
private:
	BOOL CIOThread::IORead(CKnownFile* srcfile, Requested_Block_Struct* currentblock, byte* buffer);
};
