//this file is part of eMule
//Copyright (C)2002 Merkur ( devs@emule-project.net / http://www.emule-project.net )
//
//This program is free software; you can redistribute it and/or
//modify it under the terms of the GNU General Public License
//as published by the Free Software Foundation; either
//version 2 of the License, or (at your option) any later version.
//
//This program is distributed in the hope that it will be useful,
//but WITHOUT ANY WARRANTY; without even the implied warranty of
//MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//GNU General Public License for more details.
//
//You should have received a copy of the GNU General Public License
//along with this program; if not, write to the Free Software
//Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

inline 
void CUpDownClient::MOD_Init_Post()
{
	// MOD BEGIN netfinity:
	m_ReaskSpread = CMilliSeconds((rand() % 30000) * 4) - MIN2MS(1); // +-1 minute
	m_dwUploadTimeBonus = 0;
	m_qwCumulativeDownloadBytes = 0;
	m_qwCumulativeUploadBytes = 0;
	m_dwCumulativeDownloadTime = 0;
	m_dwCumulativeUploadTime = 0;
	m_bIsModifiedClient = false;
	m_bPassiveConnectOnly = false;
	m_bAllowUploadSlot = false;
	// MOD END netfinity
      // enkeyDev: ICS
	m_incompletepartVer = 0;
      // <--- enkeyDev: ICS
}

inline
void CUpDownClient::MOD_Destruct_Post()
{
	// Ensure client isn't added back right away
	if (m_bPassiveConnectOnly)
		theApp.clientlist->m_globDeadSourceList.AddDeadSource(this);
}

inline
void CUpDownClient::MOD_ClearHelloProperties_Post()
{
	m_incompletepartVer = 0; // enkeyDev: ICS
	m_bIsModifiedClient = false;
}

inline
void CUpDownClient::MOD_SendMuleInfoPacket_AddTags(CList<CTag*> *etTags)
{
	//--------------------<<< MFCK [addon] - Support for tag ET_MOD_VERSION 0x55 [SLUGFILLER]
	etTags->AddTail(new CTag(ET_MOD_VERSION, MOD_VERSION));
	//--------------------<<< MFCK [addon] - Support for tag ET_MOD_VERSION 0x55 [SLUGFILLER]
	// enkeyDev: ICS
	etTags->AddTail(new CTag(ET_INCOMPLETEPARTS,1));
	// <--- enkeyDev: ICS
}

inline
void CUpDownClient::MOD_ProcessMuleInfoPacket_Pre()
{
	m_incompletepartVer = 0;	// enkeyDEV: ICS
}

inline
void CUpDownClient::MOD_ProcessMuleInfoPacket_Post()
{
	if( m_byDataCompVer == 0 )
	{
		m_incompletepartVer = 0;	// enkeyDEV: ICS
	}
}

inline
void CUpDownClient::MOD_SendHelloTypePacket_AddTags(CList<CTag*> *ctTags)
{
	//--------------------<<< MFCK [addon] - Support for tag ET_MOD_VERSION 0x55 [SLUGFILLER]
	ctTags->AddTail(new CTag(ET_MOD_VERSION, MOD_VERSION));
	//--------------------<<< MFCK [addon] - Support for tag ET_MOD_VERSION 0x55 [SLUGFILLER]
	// enkeyDev: ICS
	ctTags->AddTail(new CTag(ET_INCOMPLETEPARTS,1));
	// <--- enkeyDev: ICS
}

inline
void 
CUpDownClient::MOD_ResetFileStatusInfo_Pre()
{
}

const CString
CUpDownClient::GetClientModVer() const
{
	if(m_strModVersion.CompareNoCase(MOD_VERSION) == 0 && 
		!(GetHashType() == SO_EMULE && m_incompletepartVer
		  && m_nClientVersion == MAKE_CLIENT_VERSION(VERSION_MJR, VERSION_MIN, VERSION_UPDATE)
		)
	   )
		return _T("!!! Mod string thief !!!");
	if(m_strModVersion.IsEmpty() && GetHashType() == SO_EMULE && m_bIsModifiedClient
		&& m_nClientVersion <= MAKE_CLIENT_VERSION(VERSION_MJR, VERSION_MIN, VERSION_UPDATE)
	  )
		return _T("!!! Missing Mod string !!!");
	return m_strModVersion;
}
